#pragma once
#include "../../YoggieEngine/src/YoggieEngine.h"
#include "../EditorWindow.h"


class Settings : public EditorWindow {
public:
    Settings() : EditorWindow("Settings") {}

    void Draw() override;

private:
    int selectedGfxAPI = 0;
    int selectedPhysicsEngine = 0;
    glm::vec3 Gravity = glm::vec3(0.0f, -9.81f, 0.0f);
    bool ShowAdvancedOptions = false;
    bool DebugEngine = false;

    const char* PhysicsEngine[2] = {
        "PhysX",
        "Jolt Physics"
    };

    const char* GraphicsAPI[3] = {
        "OpenGL",
        "Vulkan",
        "Metal (Apple)"
    };

};
