#include "YoggieEngine.h"
#include "LayerStack.h"

LayerStack::~LayerStack()
{
	for (Layer* layer : layers) {
		layer->OnDetach();
		delete layer;
	}
}


void LayerStack::PushLayer(Layer* layer) {
	layers.emplace(layers.begin() + insertion_index, layer);
	insertion_index++;
}


void LayerStack::PopLayer(Layer* layer) {
	auto it = std::find(layers.begin(), layers.begin() + insertion_index, layer);
	if (it != layers.begin() + insertion_index) {
		layer->OnDetach();
		layers.erase(it);
		insertion_index--;

	}
}
