#version 440 core
in layout(location=0) vec3 aPos;
in layout(location=1) vec3 aNormal;
in layout(location=2) vec2 aTexCoords;

out vec3 FragPos;
out vec2 TexCoords;
out vec3 Normal;


uniform mat4 Model;
uniform mat4 View;
uniform mat4 Projection;



void main() {
    vec4 worldPos = model * vec4(aPos, 1.0f);
    FragPos = worldPos.xyz;
    TexCoords = aTexCoords;

    mat3 normalMatrix = transpose(inverse(mat3(model)));
    Normal = normalMatrix * aNormal;

    gl_Position = Projection * View * worldPos;
}